// Copyright (c) 2017 Razeware LLC
// See Copyright Notice page for details about the license.

import Foundation

// FizzBuzz Collection
// "Write a program that prints the numbers from 1 to 100. But for multiples of three print “Fizz” instead of the number and for the multiples of five print “Buzz”. For numbers which are multiples of both three and five print “FizzBuzz”."

struct FizzBuzz: RandomAccessCollection {

  var startIndex: Int {
    return 1
  }

  var endIndex: Int {
    return 101
  }

  func index(after i: Int) -> Int {
    return i + 1
  }

  func index(before i: Int) -> Int {
    return i - 1
  }

  subscript (position: Int) -> String {
    print("Position", position)

    precondition(indices.contains(position), "out of 1-100")
    switch (position%3 == 0, position%5 == 0) {
    case (false, false):
      return String(position)
    case (true, false):
      return "Fizz"
    case (false, true):
      return "Buzz"
    case (true, true):
      return "FizzBuzz"
    }
  }
}

for value in FizzBuzz().reversed().prefix(5) {
  print(value)
}

/*

let fb = FizzBuzz()
  .enumerated()
  .filter { $0.element == "Buzz" }
  .map { $0.offset + 1 }
fb
 
*/



